// virtual camera の設定
// virtual世界での距離単位1 = 実世界の1mmに相当

// 視点
final float EYE_X = 0;
final float EYE_Y = 1000;
final float EYE_Z = 2000;

// 注視点
final float TARGET_X = 0;
final float TARGET_Y = 1000;
final float TARGET_Z = 0;

// 上方向
final float UP_X = 0;
final float UP_Y = 1;
final float UP_Z = 0;

// 40.0はIntel RealSenseのデプスカメラの縦方向画角
final float FOVY = 40.0 * PI / 180.0;
final float NEAR = 100;
final float FAR = 10000;

final int IMAGE_WIDTH = 640;
final int IMAGE_HEIGHT = 480;

final int WINDOW_WIDTH = IMAGE_WIDTH;
final int WINDOW_HEIGHT = IMAGE_HEIGHT;

PGraphics pg;

void settings(){
  size(WINDOW_WIDTH, WINDOW_HEIGHT, P3D);
}

void setup()
{
  pg = createGraphics(IMAGE_WIDTH, IMAGE_HEIGHT, P3D);
  pg.noSmooth();
}

void draw()
{
  pg.beginDraw();
  pg.background(0, 128, 192);

  pg.camera(EYE_X, EYE_Y, EYE_Z, TARGET_X, TARGET_Y, TARGET_Z, UP_X, UP_Y, UP_Z);
  pg.perspective(FOVY, pg.width / float(pg.height), NEAR, FAR);
  pg.lights();
  
  pg.translate(0, 1000, 1000);
  pg.pushMatrix();
  float theta = TWO_PI * millis() / 5000;
  pg.rotateY(theta);
  pg.translate(500, 0, 0);
  pg.noStroke();
  pg.fill(0, 192, 0);
  pg.sphere(100);
  pg.popMatrix();  

  pg.endDraw();

  image(pg, 0, 0);
}
